--- provision.py.link	2014-01-10 15:05:03.000000000 -0800
+++ provision.py	2014-03-06 02:01:31.786913742 -0800
@@ -531,7 +531,7 @@ def setup_webui_node(*args):
         cfgm_host = get_control_host_string(env.roledefs['cfgm'][0])
         cfgm_ip = hstr_to_ip(cfgm_host)
         webui_host = get_control_host_string(host_string)
-        cfgm_host_password=env.passwords[host_string]
+        webui_host_password=env.passwords[host_string]
         openstack_host = get_control_host_string(env.roledefs['openstack'][0])
         openstack_ip = hstr_to_ip(openstack_host)
         ncollectors = len(env.roledefs['collector'])
@@ -553,7 +553,7 @@ def setup_webui_node(*args):
         cassandra_ip_list = [hstr_to_ip(cassandra_host) for cassandra_host in database_host_list]
         with  settings(host_string=host_string):
             with cd(INSTALLER_DIR):
-                run("PASSWORD=%s python setup-vnc-webui.py --cfgm_ip %s --openstack_ip %s --collector_ip %s --cassandra_ip_list %s" %(cfgm_host_password, cfgm_ip, openstack_ip, collector_ip, ' '.join(cassandra_ip_list)))
+                run("PASSWORD=%s python setup-vnc-webui.py --cfgm_ip %s --openstack_ip %s --collector_ip %s --cassandra_ip_list %s" %(webui_host_password, cfgm_ip, openstack_ip, collector_ip, ' '.join(cassandra_ip_list)))
 #end setup_webui
 
 @task
@@ -562,10 +562,20 @@ def setup_control():
     """Provisions control services in all nodes defined in control role."""
     execute("setup_control_node", env.host_string)
 
-def fixup_irond_config(control_host_string):
-    control_ip = hstr_to_ip(get_control_host_string(control_host_string))
-    tmp_fname = "/tmp/basicauthusers-%s" %(control_host_string)
-    for config_host_string in env.roledefs['cfgm']:
+@task
+@roles('cfgm')
+def fixup_irond_config():
+    execute("fixup_irond_config_node", env.host_string)
+
+@task
+def fixup_irond_config_node(*args):
+    for host_string in args: # env.roledefs['cfgm']
+        fixup_irond_config_control(host_string)
+
+def fixup_irond_config_control(config_host_string):
+    for control_host_string in env.roledefs['control']:
+        control_ip = hstr_to_ip(get_control_host_string(control_host_string))
+        tmp_fname = "/tmp/basicauthusers-%s" %(control_host_string)
         with settings(host_string=config_host_string):
             get("/etc/irond/basicauthusers.properties", tmp_fname)
             # replace control-node and dns proc creds
@@ -586,9 +596,9 @@ def fixup_irond_config(control_host_stri
 def setup_control_node(*args):
     """Provisions control services in one or list of nodes. USAGE: fab setup_control_node:user@1.1.1.1,user@2.2.2.2"""
     for host_string in args:
-        fixup_irond_config(host_string)
+        #fixup_irond_config(host_string)
         cfgm_host = get_control_host_string(env.roledefs['cfgm'][0])
-        cfgm_host_password=env.passwords[env.roledefs['cfgm'][0]]
+        control_host_password=env.passwords[host_string]
         cfgm_ip = hstr_to_ip(cfgm_host)
         control_host = get_control_host_string(host_string)
         tgt_ip = hstr_to_ip(control_host)
@@ -610,9 +620,9 @@ def setup_control_node(*args):
         with  settings(host_string=host_string):
             with cd(INSTALLER_DIR):
                 run("PASSWORD=%s python setup-vnc-control.py --self_ip %s --cfgm_ip %s --collector_ip %s" \
-                     %(cfgm_host_password, tgt_ip, cfgm_ip, collector_ip))
+                     %(control_host_password, tgt_ip, cfgm_ip, collector_ip))
                 if detect_ostype() == 'centos':
-                    run("PASSWORD=%s service contrail-control restart" % cfgm_host_password, pty=False)
+                    run("PASSWORD=%s service contrail-control restart" % control_host_password, pty=False)
 #end setup_control
 
 @task
@@ -639,7 +649,7 @@ def setup_vrouter_node(*args):
     for host_string in args:
         ncontrols = len(env.roledefs['control'])
         cfgm_host = get_control_host_string(env.roledefs['cfgm'][0])
-        cfgm_host_password = env.passwords[env.roledefs['cfgm'][0]]
+        compute_host_password=env.passwords[host_string]
         cfgm_ip = hstr_to_ip(cfgm_host)
         openstack_host = get_control_host_string(env.roledefs['openstack'][0])
         openstack_ip = hstr_to_ip(openstack_host)
@@ -674,7 +684,7 @@ def setup_vrouter_node(*args):
         with  settings(host_string=host_string):
             with cd(INSTALLER_DIR):
                 cmd= "PASSWORD=%s ADMIN_TOKEN=%s python setup-vnc-vrouter.py --self_ip %s --cfgm_ip %s --openstack_ip %s --openstack_mgmt_ip %s --ncontrols %s %s %s" \
-                         %(cfgm_host_password, openstack_admin_password, compute_control_ip, cfgm_ip, openstack_ip, openstack_mgmt_ip, ncontrols, get_service_token(), haproxy)
+                         %(compute_host_password, openstack_admin_password, compute_control_ip, cfgm_ip, openstack_ip, openstack_mgmt_ip, ncontrols, get_service_token(), haproxy)
                 if tgt_ip != compute_mgmt_ip: 
                     cmd = cmd + " --non_mgmt_ip %s --non_mgmt_gw %s" %( tgt_ip, tgt_gw )
                 if set_vgw:   
@@ -683,7 +693,7 @@ def setup_vrouter_node(*args):
                 run(cmd)
 #end setup_vrouter
 
-@roles('cfgm')
+@roles('control')
 @task
 def prov_control_bgp():
     cfgm_ip = hstr_to_ip(get_control_host_string(env.roledefs['cfgm'][0]))
