from mock import MagicMock, patch
import contrail_all as hooks
from test_utils import CharmTestCase

TO_PATCH = [
    'juju_log',
]
TO_PATCH_ROLE = [
    'install_all',
    'start',
    'proceed',
    'join',
]

class TestContrailAll(CharmTestCase):

    def setUp(self):
        super(TestContrailAll, self).setUp(hooks, TO_PATCH)
        super(TestContrailAll, self).setUp(hooks.role, TO_PATCH_ROLE)

    def _call_hook(self, hookname):
        hooks.hooks.execute([
            'hooks/{}'.format(hookname)])

    def test_role(self):
        self.assertEqual(hooks.role.role, 'all')
        self.assertEqual(hooks.role.also, [])
        #self.assertEqual(hooks.role.ifabs, ['install_contrail'])
        self.assertEqual(hooks.role.ifabs, [])
        self.assertEqual(hooks.role.reqd, {})
        self.assertEqual(hooks.role.knobs, {})
        #self.assertEqual(hooks.role.sfabs, ['setup_all'])
        self.assertEqual(hooks.role.sfabs, [])
        self.assertEqual(hooks.role.pfabs, [])
        self.assertFalse(hooks.role.jam)

    def test_install_hook(self):
        self._call_hook('install')
        self.install_all.assert_called_with()

    def test_start_hook(self):
        self._call_hook('start')
        #self.start.assert_called_with(clean=True)
        self.assertFalse(self.start.called)
