#!/usr/bin/python
# Juju charm hooks for contrail-collector

import sys
from charmhelpers.contrib.contrail.common import (
    Role,
)
from charmhelpers.core.hookenv import (
    log as juju_log,
    Hooks, 
    UnregisteredHookError,
)

hooks = Hooks()
role = Role('collector',
            also=['cfgm'],
            reqd={'cfgm': {},
                  'database': {}},
            knobs={})

@hooks.hook('install')
def install():
    role.install()
#end install

@hooks.hook('start')
def start():
    role.start(clean=True)
#end start

@hooks.hook('database-relation-changed',
            'cfgm-relation-changed')
def required_relation_changed():
    role.start()
#end required_relation_changed

#TODO - needed for --num_nodes and --redis_master_ip
#collector-cluster-relation-joined changed departed

def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        juju_log('Unknown hook {} - skipping.'.format(e))
#end main

if __name__ == '__main__':
    main()
