#!/usr/bin/python
# Juju charm hooks for contrail-compute

import sys
from charmhelpers.contrib.contrail.common import (
    Role,
)
from charmhelpers.core.hookenv import (
    log as juju_log,
    Hooks, 
    UnregisteredHookError,
)

hooks = Hooks()
role = Role(role='compute',
            ifabs=['install_vrouter', 
                   'upgrade_pkgs'],
            reqd={'cfgm': {'roledef': 'jamming'},
                  'control': {}, # ncontrols, not 'ip' ?
                  'openstack': {}},
            knobs={'env.interface_rename': False,
                   'service_token': "'contrail123'"},
            sfabs=['setup_vrouter'],
            pfabs=['verify_compute'],
            jam=True) # FYI

@hooks.hook('install')
def install():
    role.install()
#end install

@hooks.hook('config-changed')
def config_changed():
    role.proceed()
#end config_changed

@hooks.hook('start')
def start():
    role.start(clean=True)
#end start

@hooks.hook('cfgm-relation-joined')
def required_relation_joined():
    role.join()
#end required_relation_joined

# TODO ncontrols = len(env.roledefs['control'])
@hooks.hook('cfgm-relation-changed', 
            'control-relation-changed', 
            'openstack-relation-changed')
def required_relation_changed():
    role.start()
#end required_relation_changed

def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        juju_log('Unknown hook {} - skipping.'.format(e))
#end main

if __name__ == '__main__':
    main()
