#!/usr/bin/python
# Juju charm hooks for contrail-control

import sys
from charmhelpers.contrib.contrail.common import (
    Role,
)
from charmhelpers.core.hookenv import (
    log as juju_log,
    Hooks, 
    UnregisteredHookError,
)

hooks = Hooks()
role = Role('control',
            reqd={'cfgm': {'roledef': 'jamming'},
                  'collector': {}},
            # TODO relation-get router_asn and mt options from cfgm
            knobs={'router_asn': 64512},
            sfabs=['setup_control', 
                   'verify_control', 
                   'prov_control_bgp'])

@hooks.hook('install')
def install():
    role.install()
#end install

@hooks.hook('start')
def start():
    role.start(clean=True)
#end start

@hooks.hook('cfgm-relation-joined')
def required_relation_joined():
    role.join()
#end required_relation_joined

@hooks.hook('cfgm-relation-changed',
            'collector-relation-changed')
def required_relation_changed():
    role.start()
#end required_relation_changed

def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        juju_log('Unknown hook {} - skipping.'.format(e))
#end main

if __name__ == '__main__':
    main()
