from mock import MagicMock, patch
import contrail_database as hooks
from test_utils import CharmTestCase

TO_PATCH = [
    'juju_log',
    'charm_dir',
]
TO_PATCH_ROLE = [
    'install',
    'start',
]

class TestContrailDatabase(CharmTestCase):

    def setUp(self):
        super(TestContrailDatabase, self).setUp(hooks, TO_PATCH)
        super(TestContrailDatabase, self).setUp(hooks.role, TO_PATCH_ROLE)
        self.charm_dir.return_value = '.'

    def _call_hook(self, hookname):
        hooks.hooks.execute([
            'hooks/{}'.format(hookname)])

    def test_multi_node_allowed(self):
        returned = hooks.multi_node_allowed()
        self.assertEqual(returned, False)

    def test_role(self):
        self.assertEqual(hooks.role.role, 'database')
        self.assertEqual(hooks.role.also, [])
        self.assertEqual(hooks.role.ifabs, [])
        self.assertEqual(hooks.role.reqd, {})
        self.assertEqual(hooks.role.knobs, {})
        self.assertEqual(hooks.role.sfabs, [])
        self.assertFalse(hooks.role.jam)

    def test_install_hook(self):
        self._call_hook('install')
        self.install.assert_called_with()

    @patch('contrail_database.multi_node_allowed', lambda: False)
    def test_start_hook(self):
        self._call_hook('start')
        self.start.assert_called_with(clean=True)

