#!/usr/bin/python
# Juju charm hooks for contrail-openstack

import sys
from charmhelpers.contrib.contrail.common import (
    Role,
)
from charmhelpers.core.hookenv import (
    log as juju_log,
    Hooks, 
    UnregisteredHookError,
)

hooks = Hooks()
role = Role('openstack',
            ifabs=['install_openstack', 
                   'upgrade_pkgs', 
                   'update_keystone_log'],
            reqd={'cfgm': {}},
            knobs={'service_token': "'contrail123'"},
            sfabs=['setup_openstack'], 
            # No verify_openstack MGTODO understand
            jam=True) # cfgm needs this

@hooks.hook('install')
def install():
    role.install()
#end install

@hooks.hook('start')
def start():
    role.start(clean=True)
#end start

@hooks.hook('openstack-relation-joined',
            'keystone-relation-joined',
            'nova-relation-joined')
def provided_relation_joined():
    role.jamming()
#end provided_relation_joined

@hooks.hook('cfgm-relation-changed')
def required_relation_changed():
    role.start()
#end required_relation_changed

def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        juju_log('Unknown hook {} - skipping.'.format(e))
#end main

if __name__ == '__main__':
    main()
