#!/usr/bin/python
# Juju charm hooks for contrail-webui

import sys
from charmhelpers.contrib.contrail.common import (
    Role,
)
from charmhelpers.core.hookenv import (
    log as juju_log,
    Hooks, 
    UnregisteredHookError,
)

hooks = Hooks()
role = Role('webui', 
            also=['cfgm'],
            reqd={'cfgm': {},
                  'openstack': {}, #nova
                  'collector': {},
                  'database': {}
                  },
            knobs={})

@hooks.hook('install')
def install():
    role.install()
#end install

#config-changed - TODO - config options

@hooks.hook('start')
def start():
    role.start(clean=True)
#end start

#collector-relation- ncollectors
#webui-cluster-relation - webui_host_list.index(webui_host)

@hooks.hook('cfgm-relation-changed',
            'openstack-relation-changed',
            'collector-relation-changed',
            'database-relation-changed')
def required_relation_changed():
    role.start()
#end required_relation_changed

def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        juju_log('Unknown hook {} - skipping.'.format(e))
#end main

if __name__ == '__main__':
    main()
