from mock import MagicMock, patch
import contrail_webui as hooks
from test_utils import CharmTestCase

TO_PATCH = [
    'juju_log',
]
TO_PATCH_ROLE = [
    'install',
    'start',
]

class TestContrailWebui(CharmTestCase):

    def setUp(self):
        super(TestContrailWebui, self).setUp(hooks, TO_PATCH)
        super(TestContrailWebui, self).setUp(hooks.role, TO_PATCH_ROLE)

    def _call_hook(self, hookname):
        hooks.hooks.execute([
            'hooks/{}'.format(hookname)])

    def test_role(self):
        self.assertEqual(hooks.role.role, 'webui')
        self.assertEqual(hooks.role.also, ['cfgm'])
        self.assertEqual(hooks.role.reqd, {'openstack': {}, 'database': {}, 
                                           'collector': {}, 'cfgm': {}})
        self.assertEqual(hooks.role.knobs, {})

    def test_install_hook(self):
        self._call_hook('install')
        self.install.assert_called_with()

    def test_start_hook(self):
        self._call_hook('start')
        self.start.assert_called_with(clean=True)

    def test_required_relation_changed(self):
        self._call_hook('openstack-relation-changed')
        self.start.assert_called_with()
        self._call_hook('database-relation-changed')
        self.start.assert_called_with()
        self._call_hook('collector-relation-changed')
        self.start.assert_called_with()
        self._call_hook('cfgm-relation-changed')
        self.start.assert_called_with()
